#include <string.h>
#include <stdio.h>
#include <io.h>
#include <string.h>
#include <stdlib.h>


#define N		 4096	/* size of ring buffer */

unsigned char
		text_buf[N];	/* ring buffer of size N*/
int r;
int k;
char outbuffer_position=0;
char outbuffer[8];

FILE *f_in,*f_out,*f_dat;

int Eof(FILE *f_file)
{
	long curpos, length;
	curpos = ftell(f_file);
	fseek(f_in, 0L, SEEK_END);
	length = ftell(f_file);
	fseek(f_in, curpos, SEEK_SET);
	if (length==curpos) return(1);
	return(0);
}

void convert_binaire(char source,char valeur_binaire[8])
{
	strcpy(valeur_binaire,"00000000");
	if (source & 0x01) valeur_binaire[7]=49;
	if (source & 0x02) valeur_binaire[6]=49;
	if (source & 0x04) valeur_binaire[5]=49;
	if (source & 0x08) valeur_binaire[4]=49;
	if (source & 0x10) valeur_binaire[3]=49;
	if (source & 0x20) valeur_binaire[2]=49;
	if (source & 0x40) valeur_binaire[1]=49;
	if (source & 0x80) valeur_binaire[0]=49;
}

void convert_binaire_int(int source,char valeur_binaire[16])
{
	strcpy(valeur_binaire,"0000000000000000");
	if (source & 0x0001) valeur_binaire[15]=49;
	if (source & 0x0002) valeur_binaire[14]=49;
	if (source & 0x0004) valeur_binaire[13]=49;
	if (source & 0x0008) valeur_binaire[12]=49;
	if (source & 0x0010) valeur_binaire[11]=49;
	if (source & 0x0020) valeur_binaire[10]=49;
	if (source & 0x0040) valeur_binaire[9]=49;
	if (source & 0x0080) valeur_binaire[8]=49;
	if (source & 0x0100) valeur_binaire[7]=49;
	if (source & 0x0200) valeur_binaire[6]=49;
	if (source & 0x0400) valeur_binaire[5]=49;
	if (source & 0x0800) valeur_binaire[4]=49;
	if (source & 0x1000) valeur_binaire[3]=49;
	if (source & 0x2000) valeur_binaire[2]=49;
	if (source & 0x4000) valeur_binaire[1]=49;
	if (source & 0x8000) valeur_binaire[0]=49;

}

unsigned char convert_byte(char valeur_binaire[8],unsigned char byte)
{
	byte=0;
	if (valeur_binaire[7]=='1') byte = byte|0x01;
	if (valeur_binaire[6]=='1') byte = byte|0x02;
	if (valeur_binaire[5]=='1') byte = byte|0x04;
	if (valeur_binaire[4]=='1') byte = byte|0x08;
	if (valeur_binaire[3]=='1') byte = byte|0x10;
	if (valeur_binaire[2]=='1') byte = byte|0x20;
	if (valeur_binaire[1]=='1') byte = byte|0x40;
	if (valeur_binaire[0]=='1') byte = byte|0x80;
	return(byte);
}

long filesize(FILE *f_iso)
{
	long curpos, length;
	curpos = ftell(f_iso);
	fseek(f_iso, 0L, SEEK_END);
	length = ftell(f_iso);
	fseek(f_iso, curpos, SEEK_SET);
	return length;
}

char recherche(unsigned char buffer[21],int position[1],int r)
{
	int i,j,k;
	int result,best_result,egal;
	int best_position;

	best_result=0;

	for(i=0;i<4077;i++)
	{
		if(i==1210)
		{
			printf("boarf5");
		}
		result=0;
		k=0;
		do
		{
			if(k==17)
			{
				egal=0;
			}
			else
			{
			if((buffer[k]==text_buf[i+k])&&((i+k<r)||(i+k>r+k)))

			{
				egal=1;
				result++;
			}
			else
			{
				egal=0;
			}
			}
		k++;
		}while((egal!=0));
//		if ((i<(r-18))||(i>r))
		if (result>best_result)
		{
			best_result=result;
			best_position=i;
		}

	}
	if (best_result>=2)
	{
		position[0]=best_position;
		return(best_result);
	}
	return(-1);
}

void convert(char longeur,int position[1],unsigned char result[2])
{
	unsigned char long_temp[4];
	unsigned char pos_temp[12];
	char i;
	char temp[16];
	char temp1[8],temp2[8],temp3[8];

	convert_binaire((longeur-2),temp3);
	convert_binaire_int(position[0],temp);
	

	if(position[0]==107)
	{
		printf("boarf3");
	}

	for(i=4;i<12;i++)
		temp1[i-4]=temp[i];
	for(i=12;i<16;i++)
		temp2[i-12]=temp[i];
	for(i=4;i<8;i++)
		temp2[i]=temp3[i];
	result[0]=convert_byte(temp1,result[0]);
	result[1]=convert_byte(temp2,result[1]);
}

char add_outbuffer(unsigned char val)
{
	unsigned char out;

	outbuffer[outbuffer_position]=val;
	if(++outbuffer_position==8)
	{
		out=convert_byte(outbuffer,out);
		outbuffer_position=0;
		if (out==8)
		{
			printf("boarf");
		}
		fwrite(&out,1,1,f_out);
	}
	return(0);
}

char sortir(unsigned char valeur)
{
	char i;
	char valeur_bin[8];
	convert_binaire(valeur,valeur_bin);
	for (i=0;i<8;i++)
	{
		add_outbuffer(valeur_bin[i]);
	}
	return(0);
}

char recomp(void)
{
	long length_source;
	long position;
	unsigned char read_buf[21];
	unsigned char out_buffer[16];
	char pos_out_buf;
	char indicateur[8];
	unsigned char temp_indicateur;
	char pos_indicateur;
	unsigned char valeur;
	unsigned char valeur2[2];
	int i,j;
	char result;
	int r;
	int pos_buf[1];

	r=1;

	length_source=filesize(f_in);

	pos_indicateur=7;
	pos_out_buf=0;

	for(i=0;i<4096;i++)					// On initialise le
		text_buf[i]=0;					// text_buf.

//	for(i=0;i<64;i++)
//		add_outbuffer('0');
	i=0;
	do
	{
		if (r>=1258)
		{
			printf("boarf2");
		}
	 position=ftell(f_in);

	 for(j=0;j<18;j++)                       //
	{										//
		fread((char*)&valeur,1,1,f_in);		// on charge le buffer
		read_buf[j]=valeur;  	         // avec les 18 prochains
	 }                                       // caracteres.

	 result=recherche(read_buf,pos_buf,r); 	 // recherche dans le textbuf

	 if (result==-1)                         // si rien de trouve
	 {
		fseek(f_in,position,SEEK_SET);
		fread((char*)&valeur,1,1,f_in);
		add_outbuffer('1');
		sortir(valeur);
		text_buf[r++]=valeur;
		if (r==4096) r=0;
		i++;
	 }
	 else                   		 // si on a trouve
	 {
		fseek(f_in,position,SEEK_SET);
		convert(result,pos_buf,valeur2);
		add_outbuffer('0');
		sortir(valeur2[0]);
		sortir(valeur2[1]);
		for(k=0;k<result;k++)
		{
			i++;
			text_buf[r++]=read_buf[k];
			fread((char*)&valeur,1,1,f_in);
			if (r==4096) r=0;
		}
		//i--;
	 }
	}while(i<=length_source);
	return(0);
}


char recomp2(void)
{
	//sortir 64bits  0
	return(0);
}


int main (void)
{
	long length;
	long unknown;

	f_in=fopen("script.txt","rb");
	f_out=fopen("8script","wb+");
	f_dat=fopen("8script.dat","rb");

	length=filesize(f_in);
	fprintf(f_out,"sszl");
	fwrite(&length,4,1,f_out);

	fread((long*)&unknown,4,1,f_dat);
	fwrite(&unknown,4,1,f_out);

	recomp();
	fcloseall();
	return(0);
}

